

	.MODULE tests

	call	initostore

_testfreelistget
	ld		bc,OSTORE
	jp		_test1loop
	
_failed
	jp		0
	
_test1loop
	call	getobject

	; is hl == bc?
	;
	and		a					; clear carry
	sbc		hl,bc
	jp		nz,_failed

	; hl == bc, so  bump bc to next ostruct
	;
	push	bc
	pop		hl
	ld		bc,OSTRUCTSIZE
	add		hl,bc
	push	hl
	pop		bc

	; end of list?
	;
	ld		hl,OSTORE+(NSTRUCTS*OSTRUCTSIZE)
	and		a
	sbc		hl,bc
	jr		nz,_test1loop

	; we should have emptied the list, NEXTFREE should be at $7000,...
	ld		hl,(NEXTFREE)
	ld		bc,$7000-2
	and		a
	sbc		hl,bc
	jp		nz,_failed

	; PASSED!

_testfreelistput
	ld		b,NSTRUCTS
	ld		hl,1
_tflpl
	call	freeobject
	inc		hl
	djnz	_tflpl

	; we should have filled the list, NEXTFREE should be at $707E,...
	ld		hl,(NEXTFREE)
	ld		bc,$707E
	and		a
	sbc		hl,bc
	jp		nz,_failed

	call	getobject
	ld		a,l
	cp		$40
	jp		nz,_failed

	call	getobject
	ld		a,l
	cp		$3f
	jp		nz,_failed

	call	getobject
	call	getobject
	call	getobject
	call	getobject
	call	getobject
	call	getobject
	ld		a,l
	cp		$39
	jp		nz,_failed

	; PASSED!

_testtasklist
	call	initostore

	call	getobject				; $6000
	ld		(OSTORE+ONEXT),hl
	ld		(OSTORE+OPREV),hl

	call	getobject				; $6040
	call	insertobject_afterhead

	and		a

	; ($6000) next = $6040 prev = $6040
	; ($6040) next = $6000 prev = $6000

	ld		hl,($6000+ONEXT)
	ld		bc,$6040
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6000+OPREV)
	sbc		hl,bc
	jp		nz,_failed

	ld		hl,($6040+ONEXT)
	ld		bc,$6000
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6040+OPREV)
	sbc		hl,bc
	jp		nz,_failed

	call	getobject				; $6080
	call	insertobject_afterhead

	; ($6000) next = $6080 prev = $6040
	; ($6080) next = $6040 prev = $6000
	; ($6040) next = $6000 prev = $6080

	ld		hl,($6000+ONEXT)
	ld		bc,$6080
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6000+OPREV)
	ld		bc,$6040
	sbc		hl,bc
	jp		nz,_failed

	ld		hl,($6040+ONEXT)
	ld		bc,$6000
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6040+OPREV)
	ld		bc,$6080
	sbc		hl,bc
	jp		nz,_failed

	ld		hl,($6080+ONEXT)
	ld		bc,$6040
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6080+OPREV)
	ld		bc,$6000
	sbc		hl,bc
	jp		nz,_failed

	; enuf linking, try unlinking something!

	ld		hl,$6040
	call	unlinkobject

	; ($6000) next = $6080 prev = $6080
	; ($6080) next = $6000 prev = $6000

	ld		hl,($6000+ONEXT)
	ld		bc,$6080
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6000+OPREV)
	sbc		hl,bc
	jp		nz,_failed

	ld		hl,($6080+ONEXT)
	ld		bc,$6000
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6080+OPREV)
	sbc		hl,bc
	jp		nz,_failed

	; and once more for luck!

	call	getobject				; $6040
	ld		bc,$6040
	sbc		hl,bc
	jp		nz,_failed

	ld		hl,$6040
	call	insertobject_afterhead

	; ($6000) next = $6040 prev = $6080
	; ($6040) next = $6080 prev = $6000
	; ($6080) next = $6000 prev = $6040

	ld		hl,($6000+ONEXT)
	ld		bc,$6040
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6000+OPREV)
	ld		bc,$6080
	sbc		hl,bc
	jp		nz,_failed

	ld		hl,($6040+ONEXT)
	ld		bc,$6080
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6040+OPREV)
	ld		bc,$6000
	sbc		hl,bc
	jp		nz,_failed

	ld		hl,($6080+ONEXT)
	ld		bc,$6000
	sbc		hl,bc
	jp		nz,_failed
	ld		hl,($6080+OPREV)
	ld		bc,$6040
	sbc		hl,bc
	jp		nz,_failed

	; PASSED!
